/*
     File:       DICOM_Toolkit_Export.h

     Contains:   Escape DICOM Toolkit Initialization Interfaces.

     Copyright:  (c)2002-2004 by Escape Information Services, all rights reserved.

     Bugs?       For support or bug reports please send email to support@escape.gr
 
*/

#ifndef __DICOM_TOOLKIT_EXPORT__
#define __DICOM_TOOLKIT_EXPORT__

#ifndef __MACH__
	#ifndef __IMAGECOMPRESSION__
	    #include <ImageCompression.h>
	#endif
	#ifndef __QUICKDRAW__
	    #include <QuickDraw.h>
	#endif
#endif

#ifndef __DICOM_TOOLKIT_TYPES__
	#include "DICOM_Toolkit_Types.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT
#pragma import on
#endif

/*!
    @header DICOM_Toolkit_Export.h
    @discussion This header includes the declarations of the private functions of the
                DICOM Graphics Export component
*/

#pragma export on

typedef const DTkElemTagArrayPtr DTkConstElemTagArrayPtr;
/*!
    @function DTkGraphicsExportSetAnonymizeTagArray
    @abstract Sets the array of DICOM tags to be anonymized by the GraphicsExportDoExport call 
              applied to a DICOM file.
    @param ci              [I] The (DICOM) graphics export component instance
    @param elemTagArrayPtr [I] The array of DICOM tags
    @result Error code
*/
EXTERN_API(ComponentResult) DTkGraphicsExportSetAnonymizeTagArray(
                                                                   GraphicsExportComponent ci, 
                                                                   DTkElemTagArrayPtr elemTagArrayPtr);

#pragma export off

#ifdef PRAGMA_IMPORT_OFF
#pragma import off
#elif PRAGMA_IMPORT
#pragma import reset
#endif

#ifdef __cplusplus
}
#endif


#endif // __DICOM_TOOLKIT_EXPORT__
