/* 
	$RCSfile: DICOM_Toolkit_Parser_Utils.h,v $
	$Author: konis $
	$Source: /Volumes/Cubas/cvsroot/dicom/DTkUtils/DICOM_Toolkit_Parser_Utils.h,v $
	$Revision: 1.16 $
	$Name:  $
	
	$Log: DICOM_Toolkit_Parser_Utils.h,v $
	Revision 1.16  2008/09/30 14:54:29  konis
	Added line-feed at the end of file to eliminate warning in Xcode.
	
	Revision 1.15  2006/12/04 18:37:33  konis
	Removed deprecated funstion definition.
	
	Revision 1.14  2005/05/12 12:43:36  patrinos
	Added prototype for new call ParserGetNumDICOMDIRImages
	
	Revision 1.13  2005/03/30 11:11:37  konis
	Changed ParserGetPixelAspectRatioFactors() to return void and to report the factors as longs.
	
	Revision 1.12  2005/02/28 17:23:45  patrinos
	Added prototype of new call ParserGetPixelAspectRatioFactors
	
	Revision 1.11  2004/12/01 15:22:26  patrinos
	Made fixes to overlay code
	
	Revision 1.10  2004/01/21 14:21:34  patrinos
	Added new function ParserGetElementRawData
	
	Revision 1.9  2003/10/07 14:09:37  patrinos
	Added new calls: ParserOverlayGetDimensionsFromOverlayGroup, ParserOverlayGetDimensionsFromOverlayID,
	ParserOverlayGetOriginFromOverlayGroup, ParserOverlayGetOriginFromOverlayID
	
	Revision 1.8  2003/08/25 15:03:57  patrinos
	Added prototypes and required struct defs for calls GetApplicableFrameRanges, GetMaskFrameNumberRange and ReportMaskParameters.
	
	Revision 1.7  2003/07/18 12:38:43  patrinos
	Added new call  ParserGetElementDataAsCString
	
	Revision 1.6  2003/07/09 11:34:35  patrinos
	Added prototype of new function ParserQueryIsEnhancedMR
	
	Revision 1.5  2003/05/05 10:48:55  patrinos
	1. Made prototype of ParserGetComponentInstanceFromFSSpec dependent on whether and how QTMLCLINET is defined.
	2. ParserGetVOIParamsArray: Added imageIndex parameter to support enhanced MR file with possible frame dependent VOI parameters
	
	Revision 1.4  2003/04/21 13:19:41  patrinos
	ParserGetComponentInstanceFromFSSpec: Changed type of fssRecPtr parameter to QTML_FSSpecPtr.
	
	Revision 1.3  2003/04/21 10:07:59  patrinos
	1. Added CVS keywords
	2. Replaced type VOIParamPairArrayHandle by DTkVOIParamPairArrayImageDescExtensionHandle
	3. Deleted type definitions VOIParamPair, VOIParamPairArray
	
*/
#ifndef __DICOM_TOOLKIT_PARSER_UTILS__
#define __DICOM_TOOLKIT_PARSER_UTILS__

	#ifndef __COMPONENTS__
		#include <Components.h>
	#endif

	#ifndef __DICOM_TOOLKIT_TYPES__
		#include "DICOM_Toolkit_Types.h"
	#endif

	#ifdef __cplusplus
	extern "C" {
	#endif

	#if PRAGMA_IMPORT
	#pragma import on
	#endif

	#if PRAGMA_STRUCT_ALIGN
	    #pragma options align=mac68k
	#elif PRAGMA_STRUCT_PACKPUSH
	    #pragma pack(push, 2)
	#elif PRAGMA_STRUCT_PACK
	    #pragma pack(2)
	#endif

	typedef struct
	{
	    UInt32 numElements;
	    UInt32 arrayElemUInt32[1];
	} UInt32Array, *UInt32ArrayPtr, **UInt32ArrayHandle, ***UInt32ArrayHandlePtr;
	
	typedef UInt32 * UInt32Vect;

#if defined(QTMLCLIENT) && QTMLCLIENT == 1
	ComponentResult ParserGetComponentInstanceFromFSSpec(QTML_FSSpecPtr fssRecPtr, DTkParserComponentInstance *parser_ci);
#else
	ComponentResult ParserGetComponentInstanceFromFSSpec(FSSpecPtr fssRecPtr, DTkParserComponentInstance *parser_ci);
#endif
	ComponentResult ParserGetElementValue(DTkParserComponentInstance ci, DTkElementRef parentElementRef, UInt16 group, UInt16 element, SInt32 idx, DTkNumericValueType valueType, void * value);
	ComponentResult ParserGetElementDataAsText(DTkParserComponentInstance ci, DTkElementRef parentElementRef, UInt16 group, UInt16 element,  SInt32 itemIndex, Handle *textHandlePtr);
	ComponentResult ParserGetElementDataAsCString(DTkParserComponentInstance ci, DTkElementRef parentElementRef, UInt16 group, UInt16 element, SInt32 itemIndex, char **cStr);
	ComponentResult ParserGetElementRawData(DTkParserComponentInstance ci, DTkElementRef parentElementRef, UInt16 group, UInt16 element, Handle * dataH);
	
	/* Overlays */
	
	// Inquire
	ComponentResult ParserOverlayGetFirstGroup(DTkParserComponentInstance parser_ci, UInt16 *overlayGroup);
	ComponentResult ParserOverlayGetNextGroup(DTkParserComponentInstance parser_ci, UInt16 *overlayGroup);
	ComponentResult ParserOverlayGetOffsetsAndSizesForFile(DTkParserComponentInstance parser_ci, UInt32Vect *overlayOffsetsOut, UInt32Vect *overlaySizesOut);
	
	ComponentResult ParserOverlayGetDimensionsFromOverlayGroup(DTkParserComponentInstance parser_ci, UInt16 overlayGroup, UInt16 *overlayWidth, UInt16 *overlayHeight);
	ComponentResult ParserOverlayGetDimensionsFromOverlayID(DTkParserComponentInstance parser_ci, UInt16 overlayID, UInt16 *overlayWidth, UInt16 *overlayHeight);
	ComponentResult ParserOverlayGetOriginFromOverlayGroup(DTkParserComponentInstance parser_ci, UInt16 overlayGroup, SInt16 *overlayStartRow, SInt16 *overlayStartCol);
	ComponentResult ParserOverlayGetOriginFromOverlayID(DTkParserComponentInstance parser_ci, UInt16 overlayID, SInt16 *overlayStartRow, SInt16 *overlayStartCol);

	// Convert
	ComponentResult ParserOverlayID2Group(DTkParserComponentInstance parser_ci, SInt32 olID, UInt16 *olGroup);
	ComponentResult ParserOverlayGroup2ID(DTkParserComponentInstance parser_ci, UInt16 olGroup, SInt32 *olID);

	// Count
	ComponentResult ParserOverlayGetOverlayCountForFile(DTkParserComponentInstance parser_ci, UInt32 *overlayCount);
	ComponentResult ParserOverlayGetOverlayCountForFrame(DTkParserComponentInstance parser_ci, UInt16 imageFrameNo, UInt32 *overlayCountForFrame);
	ComponentResult ParserOverlayGetFrameCountForOverlay(DTkParserComponentInstance parser_ci, UInt16 overlayID, UInt32 *imageCount);

	// Deliver
	ComponentResult ParserOverlayGetOverlayIDsForImageFrame(DTkParserComponentInstance parser_ci, UInt16 imageFrameNo, UInt32ArrayHandlePtr olIDsForFrame);
	ComponentResult ParserOverlayGetImageIDsForOverlay(DTkParserComponentInstance parser_ci, UInt16 overlayID, UInt32ArrayHandlePtr frameIDsForOverlay);


	// Query
	ComponentResult ParserQueryIsEnhancedMR(ComponentInstance parser_ci, Boolean *isEnhancedMR);

	/* VOI params array Image description extension */
	ComponentResult ParserGetVOIParamsArray(ComponentInstance parser_ci, UInt32 imageIndexBase0, DTkVOIParamPairArrayImageDescExtensionHandle *VOIParamPairArrayHandleOut);


	/* Masks */
	ComponentResult GetMaskFrameNumberRange(DTkParserComponentInstance parser_ci, DTkElementRef parentElemRef, UInt16 *v1, UInt16 *v2);


	typedef struct
	{
		UInt32 numElements;
		UInt32 elemSize;
		UInt32 elemVector[0];
	} GenericArrayRec, *GenericArrayRecPtr, **GenericArrayRecHandle, ***GenericArrayRecHandlePtr;

	typedef struct
	{
		UInt16 rangeStart;
		UInt16 rangeFinish;
	} RangesRec, *RangesRecPtr; 

	ComponentResult GetApplicableFrameRanges(DTkParserComponentInstance parser_ci, DTkElementRef parentElemRef, GenericArrayRecHandle *rangesArray);
	ComponentResult ReportMaskParameters(DTkParserComponentInstance parser_ci);
	void ParserGetPixelAspectRatioFactors(DTkParserComponentInstance parser_ci, long *X_scaleFactor, long *Y_scaleFactor);
	ComponentResult ParserGetNumDICOMDIRImages(DTkParserComponentInstance parser_ci, UInt32 *numImages);
	

	#if PRAGMA_STRUCT_ALIGN
	    #pragma options align=reset
	#elif PRAGMA_STRUCT_PACKPUSH
	    #pragma pack(pop)
	#elif PRAGMA_STRUCT_PACK
	    #pragma pack()
	#endif

	#ifdef PRAGMA_IMPORT_OFF
	#pragma import off
	#elif PRAGMA_IMPORT
	#pragma import reset
	#endif

	#ifdef __cplusplus
	}
	#endif

#endif // __DICOM_TOOLKIT_PARSER_UTILS__
